
  //hotspot script: factboxes, infoboxes, pictureboxes
  //  working on audio options - right it now defaults 
  //     to off 
  //         S to turn the sound on 
  //         M to turn the sound off (turning it off cuts off anything that might be playing)
  //         B to turn the sound male 
  //         G to turn the sound female 
  //
  //  NOTE: Audio does not work on oculus so for now any 
  //     pages using it have to call notOculus() in onLoad.
  //  have not added "alt" for image in the PictureBox
  //     but a commented out line holds a place for code
  //
  //Copyright 2016-2024 Evan Golub (egolub@cs.umd.edu)  
  //version 0.7.9
  //non-commercial use allowed as long as these comments are included 

  var supportsAudio;
  'speechSynthesis' in window ? 
      supportsAudio = true //console.log("Web Speech API supported!") 
      : supportsAudio = false; //console.log("Web Speech API not supported :-(")
  var speakFlag = false;
  var messageToSpeak;

  if (supportsAudio == true) activateAudio();


  function turnSoundOn(silent) {
    if (supportsAudio == true) {
      speakFlag = true;
      if (silent != true) {
        messageToSpeak.text = "Turning Sound On";
        window.speechSynthesis.speak(messageToSpeak);
      }
    }
  }
  function turnSoundOff(silent) {
    if (supportsAudio == true) {
      window.speechSynthesis.cancel();
      speakFlag = false;
      if (silent != true) {
        messageToSpeak.text = "Turning Sound Off";
        window.speechSynthesis.speak(messageToSpeak);
      }
    }
  }
  function setMaleVoice() {
    if (supportsAudio == true) {
      messageToSpeak.text = "Turning Voice Male";
      var voices = window.speechSynthesis.getVoices();
      //for (var i=0; i<voices.length; i++) {
      //   console.log(voices[i]);
      //}
      messageToSpeak.voice = voices.filter(
         function(voice) {return voice.name.includes('David'); }
      )[0];
      if (speakFlag == true) {
        window.speechSynthesis.speak(messageToSpeak);
      }
    }
  }
  function setFemaleVoice() {
    if (supportsAudio == true) {
      messageToSpeak.text = "Turning Voice Female";
      var voices = window.speechSynthesis.getVoices();
      messageToSpeak.voice = voices.filter(
         function(voice) {return voice.name.includes('Zira'); }
      )[0];
      if (speakFlag == true) {
        window.speechSynthesis.speak(messageToSpeak);
      }
    }
  }
  function activateAudio() {
     messageToSpeak = new SpeechSynthesisUtterance();   
     setFemaleVoice();

     window.onbeforeunload = function(){
       if (supportsAudio == true) window.speechSynthesis.cancel();
     };
   
     window.addEventListener("keydown", event => {
       if (supportsAudio == true) {
         if (event.code == "KeyS") {
           turnSoundOn();
         }
         if (event.code == "KeyM") {
           turnSoundOff();
         }
         if (event.code == "KeyB") {
           setMaleVoice();
         }
         if (event.code == "KeyG") {
           setFemaleVoice();
         }
       }
     });
  }


  function setOuterGaze(val) {
     gazeOuterDefault=val;
  }

  var uri = window.location.href;
  var pos = uri.indexOf('?');
  if (pos!=-1) {
        if (  
              (uri.substr(pos+1,6)=='mobile')
              ||
              (uri.substr(pos+1,7)=='regular')
        )
        {
          setOuterGaze( parseFloat(gazeOuterDefault)*2);
        }
  }



  var boxPositionVisible = "";
  var boxPositionHidden = "";
  var iconPosition = ""; 
  var hiddenPosition = "";
  var imagePositionVisible = "";
  var distanceAwayBase;
  var distanceAwayImage;
  var distanceAwayText;
  var distanceAwayIcon;


  var defaultDistanceAway = 110; 
  var distanceAwayBase = defaultDistanceAway; //In case I want the defaultDistanceAway to be customizable...

  function updateDistances() {
     hiddenPosition = "0 0 0";

     distanceAwayImage = distanceAwayBase-2; 
     distanceAwayText = distanceAwayImage - 2;
     distanceAwayIcon = distanceAwayBase+64; //made this further away to avoid billboard/icon intersections 
  
     //Need these so invisible image doesn't still block circle's mouseEnter
     boxPositionHidden=hiddenPosition;
     boxPositionVisible="0 0 -"+distanceAwayBase; 

     iconPosition="0 0 -"+distanceAwayIcon;

     imagePositionVisible="0 0 -"+distanceAwayImage;

     textScale = defaultTextScale * defaultDistanceAway/distanceAwayBase;
     textTopBotScale = textScale / (1 + (110-distanceAwayBase)/defaultDistanceAway/2);
  }



  var globalScale = 1;
  function adjustScale(scaleAdj) {
     globalScale-=scaleAdj; 
 
     //find all existing ones, update them 
     var all = document.querySelectorAll("a-entity");
     for (var x=0; x<all.length; x++){
         theID = all[x].getAttribute("id");
         if (theID!=null && theID.indexOf("MyEntity-")==0) {
           all[x].setAttribute('scale',"1 1 "+globalScale);
         }
     }
  }



  //For now, fonts need different offsets...
  var systemFont0 = "https://www.cs.umd.edu/~egolub/ARDN/Hotspots/robotoSDF.fnt";
  var systemFontShader0 = "sdf";
  var systemTextSingleOffset0 = 0;
  var systemTextTopOffset0 = -4;
  var systemTextBotOffset0 = 4;
  var systemTextScale0 = 1;

  var systemFont1 = "roboto";
  var systemFontShader1 = "msdf";
  var systemTextSingleOffset1 = 0;
  var systemTextTopOffset1 = -4;
  var systemTextBotOffset1 = 4;
  var systemTextScale1 = 1;

  var systemFont2 = "mozillavr";
  var systemFontShader2 = "sdf";
  var systemTextSingleOffset2 = 1.5;
  var systemTextTopOffset2 = -2;
  var systemTextBotOffset2 = 6;
  var systemTextScale2 = 1;

  var systemFont3 = "monoid";
  var systemFontShader3 = "sdf";
  var systemTextSingleOffset3 = 0.5;
  var systemTextTopOffset3 = -2.5;
  var systemTextBotOffset3 = 3.5;
  var systemTextScale3 = 1.02;

  var systemFont4 = "sourcecodepro";
  var systemFontShader4 = "sdf";
  var systemTextSingleOffset4 = 0.5;
  var systemTextTopOffset4 = -2.5;
  var systemTextBotOffset4 = 3.5;
  var systemTextScale4 = 1;


  var defaultTextScale;
  var defaultTextTopBotScale;
  var textScale;
  var textTopBotScale;

  setDefaultFont(0); //My SDF version of Roboto...




  function getTopOffset(boxHeight,top) {
     var base = boxHeight*0.5;
     var topOffset = base + top;
     return topOffset;
  }
  function getBotOffset(boxHeight,bot) {
     var base = boxHeight*0.5;
     var bottomOffset = -1*base  + bot - ((defaultDistanceAway/distanceAwayBase)-1)/2;
     return bottomOffset
  }


  var offsetForSingleText = 0;

  var defaultFont; 
  var defaultFontShader; 
  var defaultSingleTextOffset; 
  var defaultTextTopOffset; 
  var defaultTextBotOffset; 
  var defaultTextScale; 
  function setDefaultFont(choice) {
     if (choice==0) {
        defaultFont = systemFont0;
        defaultFontShader = systemFontShader0;
        defaultSingleTextOffset = systemTextSingleOffset0;
        defaultTextTopOffset = systemTextTopOffset0;
        defaultTextBotOffset = systemTextBotOffset0;
        defaultTextScale = systemTextScale0; 
     }
     if (choice==1) {
        defaultFont = systemFont1;
        defaultFontShader = systemFontShader1;
        defaultSingleTextOffset = systemTextSingleOffset1;
        defaultTextTopOffset = systemTextTopOffset1;
        defaultTextBotOffset = systemTextBotOffset1;
        defaultTextScale = systemTextScale1; 
     }
     else if (choice==2) {
        defaultFont = systemFont2;
        defaultFontShader = systemFontShader2;
        defaultSingleTextOffset = systemTextSingleOffset2;
        defaultTextTopOffset = systemTextTopOffset2;
        defaultTextBotOffset = systemTextBotOffset2;
        defaultTextScale = systemTextScale2; 
     }
     else if (choice==3) {
        defaultFont = systemFont3;
        defaultFontShader = systemFontShader3;
        defaultSingleTextOffset = systemTextSingleOffset3;
        defaultTextTopOffset = systemTextTopOffset3;
        defaultTextBotOffset = systemTextBotOffset3;
        defaultTextScale = systemTextScale3; 
     }
     else if (choice==4) {
        defaultFont = systemFont4;
        defaultFontShader = systemFontShader4;
        defaultSingleTextOffset = systemTextSingleOffset4;
        defaultTextTopOffset = systemTextTopOffset4;
        defaultTextBotOffset = systemTextBotOffset4;
        defaultTextScale = systemTextScale4; 
     }

     offsetForSingleText = defaultSingleTextOffset;
       console.log("E: "+10 *
          ( ((defaultDistanceAway-distanceAwayBase)/defaultDistanceAway) +
            ((defaultDistanceAway-distanceAwayBase)/distanceAwayBase) ) /2
       );

     updateDistances();
  }



  function setDefaultFontFile(fontFile, fontShader, singleOffset, topOffset, botOffset, scaleVal) {
     defaultFont = fontFile;
     defaultFontShader = fontShader;

     if (singleOffset==null) {
        defaultSingleTextOffset = 0;
     } else {
        defaultSingleTextOffset = singleOffset;
     } 
     if (topOffset==null) {
        defaultTextTopOffset = -3;
     } else {
        defaultTextTopOffset = topOffset;
     } 
     if (botOffset==null) {
        defaultTextBotOffset = 6+defaultTextTopOffset;
     } else {
        defaultTextTextBotOffset = botOffset;
     } 
     if (scaleVal==null) {
        defaultTextScale = 1;
     } else {
        defaultTextScale = scaleVal;
     } 


     offsetForSingleText = defaultSingleTextOffset;
     updateDistances();
  }

 
 
  function resetCameraView() {
     var theCamera = document.getElementById('main-camera');
     theCamera.setAttribute('rotation',"0 0 0");
  }

  function prepareLighting() {
     var theScene = document.querySelector('a-scene');
     var theEntity = document.createElement('a-entity');
         theEntity.setAttribute('light',"type: ambient; color: white");
     theScene.appendChild(theEntity);
     theScene.flushToDOM();
  }

  var gazePosition = "0 0 -3.0";
  var gazeOuterDefault = "0.030";
  //gazeOuterDefault = parseFloat(gazeOuterDefault)*1;//syntax test..

  function prepareGazeTargets(gazeColor) {
     var theEntity = document.getElementById('main-camera');
     var theRingBig = document.createElement('a-ring');
         theRingBig.setAttribute('id',"gazeTarget-Big");
         theRingBig.setAttribute('visible',"true");
         theRingBig.setAttribute('radius-outer',gazeOuterDefault);
         theRingBig.setAttribute('radius-inner',parseFloat(gazeOuterDefault)*0.5);
         theRingBig.setAttribute('position',gazePosition);
         theRingBig.setAttribute('material',"color: "+gazeColor+"; shader: flat");
         theRingBig.setAttribute('cursor',"fuse: true;");
             theRingBig.setAttribute('raycaster',"objects: .clickable;");


     var theRingSmall = document.createElement('a-ring');
         theRingSmall.setAttribute('id',"gazeTarget-Small");
         theRingSmall.setAttribute('visible',"false");
         theRingSmall.setAttribute('radius-outer',"0.003");
         theRingSmall.setAttribute('radius-inner',"0.001");
         theRingSmall.setAttribute('position',gazePosition);
         theRingSmall.setAttribute('material',"color: "+gazeColor+"; shader: flat");
         theRingSmall.setAttribute('cursor',"fuse: true;");
             theRingSmall.setAttribute('raycaster',"objects: .clickable;");

     theEntity.appendChild(theRingBig);
     theEntity.appendChild(theRingSmall);
     theEntity.flushToDOM();
  }

  function setGazeTargetBig() {
     document.getElementById("gazeTarget-Big").setAttribute('visible', "true");
     document.getElementById("gazeTarget-Small").setAttribute('visible', "false");
  }
  function setGazeTargetSmall() {
     document.getElementById("gazeTarget-Small").setAttribute('visible', "true");
     document.getElementById("gazeTarget-Big").setAttribute('visible', "false");
  }





  function hideAllBoxes() {
     var all = document.querySelectorAll("a-plane");
     for (var x=0; x<all.length; x++){
         theID = all[x].getAttribute("id");
         hideBox(theID);
         // if (theID.indexOf("factbox")==0) hideBox(1,theID);
         // if (theID.indexOf("infobox")==0) hideBox(2,theID);
         // if (theID.indexOf("picturebox")==0) hideBox(3,theID);
     }
  }
  function showAllDots() {
     //this is to get the plane names since they are the one without a suffix
     var all = document.querySelectorAll("a-plane");
     for (var x=0; x<all.length; x++){
         theID = all[x].getAttribute("id");
         document.getElementById(theID+"-icon").setAttribute("position",iconPosition);
         document.getElementById(theID+"-icon").setAttribute("visible",true);
     }
  }

  function hideBox(id) {
     if (speakFlag == true) {
        window.speechSynthesis.cancel();
        console.log("Sound playback cancelled");
     }

     var type;
     theID = id; 
     if (theID.indexOf("factbox")==0) type=1;
     if (theID.indexOf("infobox")==0) type=2;
     if (theID.indexOf("picturebox")==0) type=3;
 
     //1:fact, 2:info, 3:picture
     if (type==1) {
        theText = document.getElementById(id+"-text");
        theText.setAttribute('position',hiddenPosition);
        theText.setAttribute("visible",false);

     } 
     else if (type==2) {
        theText = document.getElementById(id+"-text");
        theText.setAttribute('position',hiddenPosition);
        theText.setAttribute("visible",false);
     }
     else if (type==3) {
        theTopText = document.getElementById(id+"-top-text");
        theTopText.setAttribute('position',hiddenPosition);
        theTopText.setAttribute("visible",false);
         theImage = document.getElementById(id+"-image");
         theImage.setAttribute('position',hiddenPosition);
         theImage.setAttribute("visible",false);
        theTopText = document.getElementById(id+"-bot-text");
        theTopText.setAttribute('position',hiddenPosition);
        theTopText.setAttribute("visible",false);
     }
     
     //Hide the box itself
     document.getElementById(id).setAttribute("position",boxPositionHidden);
     document.getElementById(id).setAttribute("visible","false");
     //also make the box unclickable
     document.getElementById(id).setAttribute('class',"NOTclickable");

     //Show the now-hidden box's icon 
     document.getElementById(id+"-icon").setAttribute("position",iconPosition);
     document.getElementById(id+"-icon").setAttribute("visible",true);
     //Make the icon clickable again
     document.getElementById(id+"-icon").setAttribute('class',"clickable");

     setGazeTargetBig();
  }
  function showBox(type,id) {
     console.log("Showing: " + id);

     hideAllBoxes();

     //hide the icon for this icon
     document.getElementById(id+"-icon").setAttribute("position",hiddenPosition);
     document.getElementById(id+"-icon").setAttribute("visible",false);
     //make the icon NOT clickable
     document.getElementById(id+"-icon").setAttribute('class',"NOTclickable");

     //show the box a-plane
     document.getElementById(id).setAttribute("position",boxPositionVisible);
     document.getElementById(id).setAttribute("visible",true);
     //make the box clickable
     document.getElementById(id).setAttribute('class',"clickable");

     //show the text for this box
     //1:fact, 2:info, 3:picture
     var theTextToSpeak = "";
     if (type==1) {
        theText = document.getElementById(id+"-text");
        theText.setAttribute('position',   theText.getAttribute("realposition")  );
        theText.setAttribute("visible",true);

        theTextToSpeak = theText.getAttribute('value');
     } 
     else if (type==2) {
        theText = document.getElementById(id+"-text");
        theText.setAttribute('position',   theText.getAttribute("realposition")  );
        theText.setAttribute("visible",true);

        theTextToSpeak = theText.getAttribute('value');
     }
     else if (type==3) {
        theTopText = document.getElementById(id+"-top-text");
        theTopText.setAttribute('position',   theTopText.getAttribute("realposition")  );
        theTopText.setAttribute("visible",true);

         theImage = document.getElementById(id+"-image");
         theImage.setAttribute('position',imagePositionVisible);
         theImage.setAttribute("visible",true);

        theBotText = document.getElementById(id+"-bot-text");
        theBotText.setAttribute('position',   theBotText.getAttribute("realposition")  );
        theBotText.setAttribute("visible",true);

        theTextToSpeak = 
            theTopText.getAttribute('value') + 
            " , " + //" , image but no description yet , " + 
            theBotText.getAttribute('value');
     }
     
     theTextToSpeak = theTextToSpeak.replace(/[\t]/gm, ' , ');
     theTextToSpeak = theTextToSpeak.replace(/[\r\n]/gm, ' ');
     theTextToSpeak = new DOMParser().parseFromString(theTextToSpeak, 'text/html').body.textContent;
     if (speakFlag == true) {
        messageToSpeak.text = theTextToSpeak;
        window.speechSynthesis.speak(messageToSpeak);
        console.log(messageToSpeak.text);
     }

     console.log("Shown: " + id);
     setGazeTargetSmall();
  }



  function getSceneElement() {
     return document.querySelector('a-scene');
  }

  function createImageElement(name, aspect, image, ht) {
     if (ht==null) ht=20;
     insertSingleImageAsset("tag-"+image, image);
     var theImage = document.createElement('a-image');
         theImage.setAttribute('id',name+"-image");
         theImage.setAttribute('visible',false);
         theImage.setAttribute('position',hiddenPosition);
         theImage.setAttribute('height',ht);
         theImage.setAttribute('width',ht*aspect);
         theImage.setAttribute('src',"#tag-"+image);
     return theImage;
  }

function nothin() {}

  function createSingleTextElement(name, colorFore, width, position, text,
                         fontFace, fontShader) {
    return createTextElementHelper(name, colorFore, width, position, text, "1", fontFace, fontShader);
  }
  function createTopBotTextElement(name, colorFore, width, position, text,
                         fontFace, fontShader) {
    return createTextElementHelper(name, colorFore, width, position, text, "2", fontFace, fontShader);
  }
  function createTextElementHelper(name, colorFore, width, position, text, typeOfText, 
                         fontFace, fontShader) {
     var theText = document.createElement('a-text');
         theText.setAttribute('id',name);
         theText.setAttribute('color',colorFore);
         theText.setAttribute('visible',"false");
         theText.setAttribute('align',"center");
         theText.setAttribute('baseline',"center");
         theText.setAttribute('width',(width-2));
         theText.setAttribute('wrap-count',(width-2)/2);
         theText.setAttribute('position',hiddenPosition);
         theText.setAttribute('realposition',position);
         if (typeOfText=="1") {
            theText.setAttribute('scale',textScale + " " + textScale + " 1");
         } else {
            theText.setAttribute('scale',textTopBotScale + " " + textTopBotScale + " 1");
         }
         theText.setAttribute('value',text);

         //For now user-defined font/fontImage must be in folder with pano
         theText.setAttribute('font', fontFace);
         theText.setAttribute('shader', fontShader);
         //theText.setAttribute('negate', "false");
         //maybe https://www.npmjs.com/package/msdf-bmfont-xml to make fnt files

         //theText.setAttribute('onMouseEnter',"console.log('entering text');");
         //theText.setAttribute('onMouseLeave',"console.log('leaving text');");
       
     return theText;
  }

  //If we decide to revamp how the text and box are done and use aframe 1.3.0 then we can 
  //     geometry="primitive:plane"
  //  and make the text .clickable
  //  and I think set the width but have the height as auto...
  function createPlaneElement(name, type, colorBack, width, height, position) {
     var thePlane = document.createElement('a-plane');
         thePlane.setAttribute('onMouseLeave',"hideBox('"+name+"');");
         thePlane.setAttribute('id',name);
         thePlane.setAttribute('visible',"false");
         thePlane.setAttribute('color',colorBack);
         thePlane.setAttribute('width',width);
         thePlane.setAttribute('height',height);
         thePlane.setAttribute('depth',"1");
         thePlane.setAttribute('position',boxPositionHidden); 
         thePlane.setAttribute('class',"NOTclickable"); //will become clickable when it appears so mouse can leave
     return thePlane;
  }

  function createCircleElement(name, type, dotOpacity) {
     if (type==1) symbol="#factboxSymbol";
     else if (type==2) symbol="#infoboxSymbol";
     else if (type==3) symbol="#pictureboxSymbol";

     var theCircle = document.createElement('a-circle');
         theCircle.setAttribute('onMouseEnter',"showBox("+type+",'"+name+"');");
         theCircle.setAttribute('id',name+"-icon");
         theCircle.setAttribute('visible',"false");
         theCircle.setAttribute('src',symbol);
         theCircle.setAttribute('opacity',dotOpacity);
         theCircle.setAttribute('radius',"4");
         theCircle.setAttribute('position',iconPosition);
             theCircle.setAttribute('class',"clickable");
     return theCircle;
  }

  var myEntitiesCount = 0;
  function createEntityElement(coords) {
     var theEntity = document.createElement('a-entity');
         theEntity.setAttribute('rotation',coords+" 0");
         theEntity.setAttribute('id',"MyEntity-"+(myEntitiesCount++));
         theEntity.setAttribute('scale',"1 1 "+globalScale);
     return theEntity; 
  }



  var factboxCounter=0;
  function insertSingleFactBox(
                coords, fact, 
                boxWidth, boxHeight,
                colorFore, colorBack, 
                dotOpacity,
                fontFace, fontShader, singleOffset
  ) {

     if (boxWidth==null) boxWidth="60";
     if (boxHeight==null) boxHeight="15";
     if (colorFore==null) colorFore="black";
     if (colorBack==null) colorBack="yellow";
     if (dotOpacity==null) dotOpacity="0.75";
     if (fontFace==null) {
        fontFace=defaultFont;
        fontShader=defaultFontShader;
        localSingleOffset=defaultSingleTextOffset;
     }
     else {
        localSingleOffset=singleOffset;
     }

     var boxname = "factbox"+factboxCounter;
     factboxCounter++;

     var theScene = getSceneElement();
     var theText = createSingleTextElement(
            boxname+"-text", 
            colorFore, boxWidth, 
            "0 "+localSingleOffset+" -"+distanceAwayText, 
            fact, fontFace, fontShader
     );
     var thePlane = createPlaneElement(boxname, 1, colorBack, boxWidth, boxHeight);
     var theCircle = createCircleElement(boxname, 1, dotOpacity);
     var theEntity = createEntityElement(coords);

     theCircle.setAttribute("visible",true);

     theEntity.appendChild(theText);
     theEntity.appendChild(thePlane);
     theEntity.appendChild(theCircle);
     theScene.appendChild(theEntity);
     theScene.flushToDOM();

  }


  var infoboxCounter=0;
  function insertSingleInfoBox(
                coords, heading, bullets,
                boxWidth, boxHeight,
                colorFore, colorBack,
                dotOpacity,
                fontFace, fontShader, singleOffset
  ) {

     if (boxWidth==null) boxWidth="70";
     if (boxHeight==null) boxHeight=6*(2+bullets.length)
     if (colorFore==null) colorFore="black";
     if (colorBack==null) colorBack="beige";
     if (dotOpacity==null) dotOpacity="0.75";
     if (fontFace==null) {
        fontFace=defaultFont;
        fontShader=defaultFontShader;
        localSingleOffset=defaultSingleTextOffset;
     }
     else {
        localSingleOffset=singleOffset;
     }

 
     var boxname = "infobox"+infoboxCounter;
     infoboxCounter++;
 

     var theScene = document.querySelector('a-scene');
 
     var i;
     var separate = "";
/*
     var linesymbol = "-";
     for (i=0; i<heading.length; i++) separate+=linesymbol;
*/
     separate = "\n\t\n";
     var listContents = "";
     for (i=0; i<bullets.length; i++) listContents+=(bullets[i]+"\t\n");
     var fullContents = heading+separate+listContents;
     var theText = createSingleTextElement(
            boxname+"-text", 
            colorFore, boxWidth, 
            "0 "+localSingleOffset+" -"+distanceAwayText, 

            fullContents, fontFace, fontShader
     );

 
     var thePlane = createPlaneElement(boxname, 2, colorBack, boxWidth, boxHeight);
     var theCircle = createCircleElement(boxname, 2, dotOpacity);
     var theEntity = createEntityElement(coords);
 
     theCircle.setAttribute("visible",true);

     theEntity.appendChild(theText);
     theEntity.appendChild(thePlane);
     theEntity.appendChild(theCircle);
     theScene.appendChild(theEntity);
     theScene.flushToDOM();
  }


  var pictureboxCounter=0;
  function insertSinglePictureBox(
                coords, captionTop, 
                image, ht,
                captionBot,
                boxWidth, boxHeight,
                colorFore, colorBack,
                dotOpacity, 
                fontFace, fontShader, custTopOffset, custBotOffset
  ) {

     var localTopOffset, localBotOffset;
     if (captionTop==null || captionTop==undefined) captionTop="";
     if (captionBot==null) captionBot="";
     if (ht==null) ht=20;
     if (boxWidth==null) boxWidth="50";
     if (boxHeight==null) boxHeight="30";
     if (colorFore==null) colorFore="black";
     if (colorBack==null) colorBack="lightblue";
     if (dotOpacity==null) dotOpacity="0.75";
     if (fontFace==null) {
        fontFace=defaultFont;
        fontShader=defaultFontShader;
        localTopOffset=getTopOffset(boxHeight,defaultTextTopOffset);
        localBotOffset=getBotOffset(boxHeight,defaultTextBotOffset);
     }
     else {
        localTopOffset=getTopOffset(boxHeight,custTopOffset);
        localBotOffset=getBotOffset(boxHeight,custBotOffset);
     }
     var img = new Image();
     img.onload = function() {
                    insertSinglePictureBoxHelper(
                       coords, captionTop, 
                       image, this.width/this.height, ht,
                       captionBot,
                       boxWidth, boxHeight,
                       colorFore, colorBack,
                       dotOpacity, 
                       fontFace, fontShader, 
                       localTopOffset, localBotOffset
                    );
     }
     img.src = image;
     //NOTE: i-dot will not appear until the image has been loaded???
  }
  function insertSinglePictureBoxHelper(
                coords, captionTop, 
                image, aspect, ht,
                captionBot,
                boxWidth, boxHeight,
                colorFore, colorBack,
                dotOpacity, 
                fontFace, fontShader, 
                topOffset, botOffset
  ) {
     var boxname = "picturebox"+pictureboxCounter;
     pictureboxCounter++;

     var theScene = getSceneElement();
     var theImage = createImageElement(boxname, aspect, image, ht);

     var theText01 = createTopBotTextElement(
            boxname+"-top-text", 
            colorFore, boxWidth, 
            "0 "+topOffset+" -"+distanceAwayText, 
            captionTop, fontFace, fontShader
     );
     var theText02 = createTopBotTextElement(
            boxname+"-bot-text", 
            colorFore, boxWidth, 
            "0 "+botOffset+" -"+distanceAwayText, 
            captionBot, fontFace, fontShader
     );
     var thePlane = createPlaneElement(boxname, 3, colorBack, boxWidth, boxHeight);
     var theCircle = createCircleElement(boxname, 3, dotOpacity);
     var theEntity = createEntityElement(coords);

     theCircle.setAttribute("visible",true);

     theEntity.appendChild(theText01);
     theEntity.appendChild(theImage);
     theEntity.appendChild(theText02);
     theEntity.appendChild(thePlane);
     theEntity.appendChild(theCircle);
     theScene.appendChild(theEntity);
     theScene.flushToDOM();
 
     //setTimeout(prepDotsAndBoxes(), 1000); //so that once the photo loads, the i-dot appears?
  }



  function insertSingleImageAsset(imageTag, imageLocation) {
     var theScene = document.querySelector('a-scene');
     var theAssetsList = document.createElement('a-assets');
     var theImg = document.createElement('img');
         theImg.setAttribute('id',imageTag);
         theImg.setAttribute('src',imageLocation);
     theAssetsList.appendChild(theImg);
     theScene.appendChild(theAssetsList);
     theScene.flushToDOM();
  }




  function setupBoxesHelper(gazeColor) {
     resetCameraView(); //reset the camera's direction
     prepareGazeTargets(gazeColor);
     prepareLighting();
     hideAllBoxes();
     showAllDots();

     return true;
  }
  function setupBoxes(gazeColor) {
     setTimeout(setupBoxesHelper.bind(null, gazeColor), 1000);
  }



  function hide360(id) {
     document.getElementById(id).setAttribute("material","opacity",0.00001);
  }
  function show360(id) {
     document.getElementById(id).setAttribute("material","opacity",1);
  }

  function revealTrue360() {
     hide360("loading");
     show360("scene");
  }

  function setupReveal(delay) {
     if (delay==null) delay=1000;
     setTimeout(revealTrue360,delay);
  }



